Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90	(revision 5116)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90	(revision 5117)
@@ -377,5 +377,5 @@
   DO l = 1, nlay - 2
     DO ig = 1, ngrid
-      ! if (zw2(ig,l).lt.1.e-10.and.ztv(ig,l).gt.ztv(ig,l+1)) THEN
+      ! if (zw2(ig,l).lt.1.e-10.AND.ztv(ig,l).gt.ztv(ig,l+1)) THEN
       ! PRINT*,'COUCOU ',l,zw2(ig,l),ztv(ig,l),ztv(ig,l+1)
       IF (zw2(ig,l)<1.E-10 .AND. ztv(ig,l)>ztv(ig,l+1) .AND. &
@@ -388,8 +388,8 @@
         fmc(ig, l+1) = entr(ig, l)
         zw2(ig, l) = 0.
-        ! if (.not.ztv(ig,l+1).gt.150.) THEN
+        ! if (.NOT.ztv(ig,l+1).gt.150.) THEN
         ! PRINT*,'ig,l+1,ztv(ig,l+1)'
         ! PRINT*, ig,l+1,ztv(ig,l+1)
-        ! endif
+        ! END IF
         zw2(ig, l+1) = 2.*rg*(ztv(ig,l)-ztv(ig,l+1))/ztv(ig, l+1)* &
           (zlev(ig,l+1)-zlev(ig,l))
@@ -398,5 +398,5 @@
         ! Incrementation...
         fmc(ig, l+1) = fmc(ig, l) + entr(ig, l)
-        ! if (.not.fmc(ig,l+1).gt.1.e-15) THEN
+        ! if (.NOT.fmc(ig,l+1).gt.1.e-15) THEN
         ! PRINT*,'ig,l+1,fmc(ig,l+1)'
         ! PRINT*, ig,l+1,fmc(ig,l+1)
@@ -405,5 +405,5 @@
         ! PRINT*,'Tv ',(ztv(ig,ll),ll=1,klev)
         ! PRINT*,'Entr ',(entr(ig,ll),ll=1,klev)
-        ! endif
+        ! END IF
         ztva(ig, l) = (fmc(ig,l)*ztva(ig,l-1)+entr(ig,l)*ztv(ig,l))/ &
           fmc(ig, l+1)
@@ -452,17 +452,17 @@
     DO ig = 1, ngrid
       IF (l<=lmaxa(ig)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         larg_detr(ig, l) = sqrt(l_mix*zlev(ig,l))
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -670,9 +670,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -1431,5 +1431,5 @@
         ! entr_star(ig,l)=0.
         ! detr_star(ig,l)=f_star(ig,l)+alim_star(ig,l)
-        ! endif
+        ! END IF
         ! test sur le signe de f_star
         IF (f_star(ig,l+1)>1.E-10) THEN
@@ -1448,5 +1448,5 @@
             l)+entr_star(ig,l))*zthl(ig,l))/(f_star(ig,l+1)+detr_star(ig,l))
           ! s                    /(f_star(ig,l+1))
-          ! endif
+          ! END IF
           ! on rajoute un excès de q dans la couche alim
           ! if (l.lt.lentr(ig)) THEN
@@ -1458,5 +1458,5 @@
             l)+entr_star(ig,l))*po(ig,l))/(f_star(ig,l+1)+detr_star(ig,l))
           ! s                   /(f_star(ig,l+1))
-          ! endif
+          ! END IF
           ! AM on en deduit thetav et ql du thermique
           ! CR test
@@ -1515,5 +1515,5 @@
           ztva(ig, l) = ztva(ig, l)*(1.+retv*(zqta(ig,l)-zqla(ig, &
             l))-zqla(ig,l))
-          ! endif
+          ! END IF
           ! ztva(ig,l) = ztla(ig,l)*zpspsk(ig,l)+RLvCp*zqla(ig,l)
           ! s                 /(1.-retv*zqla(ig,l))
@@ -1528,5 +1528,5 @@
           ! enddo
           ! DO ig=1,ngrid
-          ! if (zw2(ig,l).ge.1.e-10.and.
+          ! if (zw2(ig,l).ge.1.e-10.AND.
           ! s               f_star(ig,l)+entr_star(ig,l).gt.1.e-10) THEN
           ! mise a jour de la vitesse ascendante (l'air entraine de la couche
@@ -1550,5 +1550,5 @@
         zw2(ig, l+1) = 0.
         ! PRINT*,'linter=',linter(ig)
-        ! else if ((zw2(ig,l+1).lt.1.e-10).and.(zw2(ig,l+1).ge.0.)) THEN
+        ! ELSE IF ((zw2(ig,l+1).lt.1.e-10).AND.(zw2(ig,l+1).ge.0.)) THEN
         ! linter(ig)=l+1
         ! PRINT*,'linter=l',zw2(ig,l),zw2(ig,l+1)
@@ -1687,5 +1687,5 @@
   ! s                       -0.9*masse(ig,l)/ptimestep
   ! alim(ig,l)=0.9*masse(ig,l)/ptimestep
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -1712,5 +1712,5 @@
   ! PRINT*,'d2+e2+a2>m2','ig=',ig,'l=',l,'lmax(ig)=',lmax(ig),'d+e+a='
   ! s,(detr(ig,l)+entr(ig,l)+alim(ig,l))*ptimestep,'m=',masse(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -1732,18 +1732,18 @@
         ! PRINT*,'fmc1<0',l+1,lmax(ig),fmc(ig,l+1)
       END IF
-      ! if ((fmc(ig,l+1).gt.fmc(ig,l)).and.(l.gt.lentr(ig))) THEN
+      ! if ((fmc(ig,l+1).gt.fmc(ig,l)).AND.(l.gt.lentr(ig))) THEN
       ! f_old=fmc(ig,l+1)
       ! fmc(ig,l+1)=fmc(ig,l)
       ! detr(ig,l)=detr(ig,l)+f_old-fmc(ig,l+1)
-      ! endif
-
-      ! if ((fmc(ig,l+1).gt.fmc(ig,l)).and.(l.gt.lentr(ig))) THEN
+      ! END IF
+
+      ! if ((fmc(ig,l+1).gt.fmc(ig,l)).AND.(l.gt.lentr(ig))) THEN
       ! f_old=fmc(ig,l+1)
       ! fmc(ig,l+1)=fmc(ig,l)
       ! detr(ig,l)=detr(ig,l)+f_old-fmc(ig,l)
-      ! endif
+      ! END IF
       ! rajout du test sur alpha croissant
       ! if test
-      ! if (1.eq.0) THEN
+      ! if (1.EQ.0) THEN
       IF (l==klev) THEN
         PRINT *, 'THERMCELL PB ig=', ig, '   l=', l
@@ -1751,6 +1751,6 @@
         CALL abort_physic(modname, abort_message, 1)
       END IF
-      ! if ((zw2(ig,l+1).gt.1.e-10).and.(zw2(ig,l).gt.1.e-10).and.
-      ! s     (l.ge.lentr(ig)).and.
+      ! if ((zw2(ig,l+1).gt.1.e-10).AND.(zw2(ig,l).gt.1.e-10).AND.
+      ! s     (l.ge.lentr(ig)).AND.
       IF ((zw2(ig,l+1)>1.E-10) .AND. (zw2(ig,l)>1.E-10) .AND. (l>=lentr(ig))) &
           THEN
@@ -1789,5 +1789,5 @@
       ! lmax(ig)=l+1
       ! zmax(ig)=zlev(ig,lmax(ig))
-      ! endif
+      ! END IF
       IF (zw2(ig,l+1)>1.E-10) THEN
         IF ((((fmc(ig,l+1))/(rhobarz(ig,l+1)*zw2(ig,l+1)))>1.)) THEN
@@ -1803,15 +1803,15 @@
       END IF
       ! WRITE(1,*)'ig,l,fm(ig,l)',ig,l,fm(ig,l)
-      ! endif test
-      ! endif
-    END DO
-  END DO
-  DO ig = 1, ngrid
-    ! if (fmc(ig,lmax(ig)+1).ne.0.) THEN
+      ! END IF test
+      ! END IF
+    END DO
+  END DO
+  DO ig = 1, ngrid
+    ! if (fmc(ig,lmax(ig)+1).NE.0.) THEN
     fmc(ig, lmax(ig)+1) = 0.
     entr(ig, lmax(ig)) = 0.
     detr(ig, lmax(ig)) = fmc(ig, lmax(ig)) + entr(ig, lmax(ig)) + &
       alim(ig, lmax(ig))
-    ! endif
+    ! END IF
   END DO
   ! test sur le signe de fmc
@@ -1932,5 +1932,5 @@
     DO ig = 1, ngrid
       IF (l<=lmax(ig) .AND. (test(ig)==1)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         IF ((l_mix*zlev(ig,l))<0.) THEN
@@ -1944,14 +1944,14 @@
           larg_detr(ig, l) = sqrt(l_mix*zlev(ig,l))
         END IF
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -2215,9 +2215,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -2262,5 +2262,5 @@
         ! else
         ! nuage=.FALSE.
-        ! endif
+        ! END IF
       END DO
     END DO
@@ -2281,5 +2281,5 @@
         ! else
         ! ratqscth(ig,l)=0.
-        ! endif
+        ! END IF
       END DO
     END DO
@@ -2979,17 +2979,17 @@
     DO ig = 1, ngrid
       IF (l<=lmaxa(ig)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         larg_detr(ig, l) = sqrt(l_mix*zlev(ig,l))
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -3230,9 +3230,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -3711,5 +3711,5 @@
       ! f(ig)=f(ig)+(f0(ig)-f(ig))*exp(-ptimestep/zmax(ig)
       ! s             *wmax(ig))
-      ! endif
+      ! END IF
     END IF
     ! f0(ig)=f(ig)
@@ -3757,5 +3757,5 @@
     DO ig = 1, ngrid
       IF (l<=lmaxa(ig)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         IF ((l_mix*zlev(ig,l))<0.) THEN
@@ -3763,14 +3763,14 @@
         END IF
         larg_detr(ig, l) = sqrt(l_mix*zlev(ig,l))
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -4040,9 +4040,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -4071,5 +4071,5 @@
     ! detr(ig,l)=0.
     ! PRINT*,'WARNING !!! detrainement negatif ',ig,l
-    ! endif
+    ! END IF
     ! enddo
     ! enddo
@@ -4212,5 +4212,5 @@
       ! if (dq(ig,k).lt.0.) THEN
       ! PRINT*,'dq<0!!!'
-      ! endif
+      ! END IF
     END DO
   END DO
@@ -4982,5 +4982,5 @@
       ! f(ig)=f(ig)+(f0(ig)-f(ig))*exp(-ptimestep/zmax(ig)
       ! s             *wmax(ig))
-      ! endif
+      ! END IF
     END IF
     ! f0(ig)=f(ig)
@@ -5039,5 +5039,5 @@
     DO ig = 1, ngrid
       IF (l<=lmaxa(ig)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         IF ((l_mix*zlev(ig,l))<0.) THEN
@@ -5052,14 +5052,14 @@
         END IF
         ! RC
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -5329,9 +5329,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -5712,5 +5712,5 @@
     END DO
   END DO
-  ! endif
+  ! END IF
   ! pas de thermique si couche 1 stable
   DO ig = 1, ngrid
@@ -5893,5 +5893,5 @@
       ! if (first) THEN
       f(ig) = f(ig) + (f0(ig)-f(ig))*exp(-ptimestep/zmax(ig)*wmax(ig))
-      ! endif
+      ! END IF
     END IF
     f0(ig) = f(ig)
@@ -5916,5 +5916,5 @@
   ! s                       -0.9*masse(ig,l)/ptimestep
   ! entr(ig,l)=0.9*masse(ig,l)/ptimestep
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -5953,5 +5953,5 @@
     DO ig = 1, ngrid
       IF (l<=lmaxa(ig)) THEN
-        ! if (idetr.eq.0) THEN
+        ! if (idetr.EQ.0) THEN
         ! cette option est finalement en dur.
         IF ((l_mix*zlev(ig,l))<0.) THEN
@@ -5966,14 +5966,14 @@
         END IF
         ! RC
-        ! else if (idetr.eq.1) THEN
+        ! ELSE IF (idetr.EQ.1) THEN
         ! larg_detr(ig,l)=larg_cons(ig,l)
         ! s            *sqrt(l_mix*zlev(ig,l))/larg_cons(ig,lmix(ig))
-        ! else if (idetr.eq.2) THEN
+        ! ELSE IF (idetr.EQ.2) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *sqrt(wa_moy(ig,l))
-        ! else if (idetr.eq.4) THEN
+        ! ELSE IF (idetr.EQ.4) THEN
         ! larg_detr(ig,l)=sqrt(l_mix*zlev(ig,l))
         ! s            *wa_moy(ig,l)
-        ! endif
+        ! END IF
       END IF
     END DO
@@ -6245,9 +6245,9 @@
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdtadj=',pdtadj(ig,l)
-  ! endif
+  ! END IF
   ! IF(abs(pdoadj(ig,l))*86400..gt.1.) THEN
   ! PRINT*,'WARN!!! ig=',ig,'  l=',l
   ! s         ,'   pdoadj=',pdoadj(ig,l)
-  ! endif
+  ! END IF
   ! enddo
   ! enddo
@@ -6276,5 +6276,5 @@
     ! detr(ig,l)=0.
     ! PRINT*,'WARNING !!! detrainement negatif ',ig,l
-    ! endif
+    ! END IF
     ! enddo
     ! enddo
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_plume.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_plume.f90	(revision 5116)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_plume.f90	(revision 5117)
@@ -34,71 +34,71 @@
     IMPLICIT NONE
 
-    integer, intent(in) :: itap, lev_out, lunout1, igout, ngrid, nlay
-    real, intent(in) :: ptimestep
-    real, intent(in), dimension(ngrid, nlay) :: ztv
-    real, intent(in), dimension(ngrid, nlay) :: zthl
-    real, intent(in), dimension(ngrid, nlay) :: po
-    real, intent(in), dimension(ngrid, nlay) :: zl
-    real, intent(in), dimension(ngrid, nlay) :: rhobarz
-    real, intent(in), dimension(ngrid, nlay + 1) :: zlev
-    real, intent(in), dimension(ngrid, nlay + 1) :: pplev
-    real, intent(in), dimension(ngrid, nlay) :: pphi
-    real, intent(in), dimension(ngrid, nlay) :: zpspsk
-    real, intent(in), dimension(ngrid) :: f0
-
-    integer, intent(out) :: lalim(ngrid)
-    real, intent(out), dimension(ngrid, nlay) :: alim_star
-    real, intent(out), dimension(ngrid) :: alim_star_tot
-    real, intent(out), dimension(ngrid, nlay) :: detr_star
-    real, intent(out), dimension(ngrid, nlay) :: entr_star
-    real, intent(out), dimension(ngrid, nlay + 1) :: f_star
-    real, intent(out), dimension(ngrid, nlay) :: csc
-    real, intent(out), dimension(ngrid, nlay) :: ztva
-    real, intent(out), dimension(ngrid, nlay) :: ztla
-    real, intent(out), dimension(ngrid, nlay) :: zqla
-    real, intent(out), dimension(ngrid, nlay) :: zqta
-    real, intent(out), dimension(ngrid, nlay) :: zha
-    real, intent(out), dimension(ngrid, nlay + 1) :: zw2
-    real, intent(out), dimension(ngrid, nlay + 1) :: w_est
-    real, intent(out), dimension(ngrid, nlay) :: ztva_est
-    real, intent(out), dimension(ngrid, nlay) :: zqsatth
-    integer, intent(out), dimension(ngrid) :: lmix(ngrid)
-    integer, intent(out), dimension(ngrid) :: lmix_bis(ngrid)
-    real, intent(out), dimension(ngrid) :: linter(ngrid)
-
-    REAL, dimension(ngrid, nlay + 1) :: wa_moy
-    REAL, dimension(ngrid, nlay) :: entr, detr
-    REAL, dimension(ngrid, nlay) :: ztv_est
-    REAL, dimension(ngrid, nlay) :: zqla_est
-    REAL, dimension(ngrid, nlay) :: zta_est
-    REAL, dimension(ngrid) :: ztemp, zqsat
+    INTEGER, INTENT(IN) :: itap, lev_out, lunout1, igout, ngrid, nlay
+    REAL, INTENT(IN) :: ptimestep
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: ztv
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: zthl
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: po
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: zl
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: rhobarz
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay + 1) :: zlev
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay + 1) :: pplev
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: pphi
+    REAL, INTENT(IN), DIMENSION(ngrid, nlay) :: zpspsk
+    REAL, INTENT(IN), DIMENSION(ngrid) :: f0
+
+    INTEGER, INTENT(OUT) :: lalim(ngrid)
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: alim_star
+    REAL, INTENT(OUT), DIMENSION(ngrid) :: alim_star_tot
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: detr_star
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: entr_star
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay + 1) :: f_star
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: csc
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ztva
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ztla
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: zqla
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: zqta
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: zha
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay + 1) :: zw2
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay + 1) :: w_est
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: ztva_est
+    REAL, INTENT(OUT), DIMENSION(ngrid, nlay) :: zqsatth
+    INTEGER, INTENT(OUT), DIMENSION(ngrid) :: lmix(ngrid)
+    INTEGER, INTENT(OUT), DIMENSION(ngrid) :: lmix_bis(ngrid)
+    REAL, INTENT(OUT), DIMENSION(ngrid) :: linter(ngrid)
+
+    REAL, DIMENSION(ngrid, nlay + 1) :: wa_moy
+    REAL, DIMENSION(ngrid, nlay) :: entr, detr
+    REAL, DIMENSION(ngrid, nlay) :: ztv_est
+    REAL, DIMENSION(ngrid, nlay) :: zqla_est
+    REAL, DIMENSION(ngrid, nlay) :: zta_est
+    REAL, DIMENSION(ngrid) :: ztemp, zqsat
     REAL zdw2, zdw2bis
     REAL zw2modif
     REAL zw2fact, zw2factbis
-    REAL, dimension(ngrid, nlay) :: zeps
-
-    REAL, dimension(ngrid) :: wmaxa
+    REAL, DIMENSION(ngrid, nlay) :: zeps
+
+    REAL, DIMENSION(ngrid) :: wmaxa
 
     INTEGER ig, l, k, lt, it, lm, nbpb
 
-    real, dimension(ngrid, nlay) :: zbuoy, gamma, zdqt
-    real zdz, zalpha, zw2m
-    real, dimension(ngrid, nlay) :: zbuoyjam, zdqtjam
-    real zdz2, zdz3, lmel, entrbis, zdzbis
-    real, dimension(ngrid) :: d_temp
-    real ztv1, ztv2, factinv, zinv, zlmel
-    real zlmelup, zlmeldwn, zlt, zltdwn, zltup
-    real atv1, atv2, btv1, btv2
-    real ztv_est1, ztv_est2
-    real zcor, zdelta, zcvm5, qlbef
-    real zbetalpha, coefzlmel
-    real eps
-    logical Zsat
-    LOGICAL, dimension(ngrid) :: active, activetmp
+    REAL, DIMENSION(ngrid, nlay) :: zbuoy, gamma, zdqt
+    REAL zdz, zalpha, zw2m
+    REAL, DIMENSION(ngrid, nlay) :: zbuoyjam, zdqtjam
+    REAL zdz2, zdz3, lmel, entrbis, zdzbis
+    REAL, DIMENSION(ngrid) :: d_temp
+    REAL ztv1, ztv2, factinv, zinv, zlmel
+    REAL zlmelup, zlmeldwn, zlt, zltdwn, zltup
+    REAL atv1, atv2, btv1, btv2
+    REAL ztv_est1, ztv_est2
+    REAL zcor, zdelta, zcvm5, qlbef
+    REAL zbetalpha, coefzlmel
+    REAL eps
+    LOGICAL Zsat
+    LOGICAL, DIMENSION(ngrid) :: active, activetmp
     REAL fact_gamma, fact_gamma2, fact_epsilon2
 
-    REAL, dimension(ngrid, nlay) :: c2
-
-    if (ngrid==1) PRINT*, 'THERMCELL PLUME MODIFIE 2014/07/11'
+    REAL, DIMENSION(ngrid, nlay) :: c2
+
+    IF (ngrid==1) PRINT*, 'THERMCELL PLUME MODIFIE 2014/07/11'
     Zsat = .FALSE.
     ! Initialisation
@@ -108,5 +108,5 @@
 
     ! Initialisations des variables r?elles
-    if (1==1) THEN
+    IF (1==1) THEN
       ztva(:, :) = ztv(:, :)
       ztva_est(:, :) = ztva(:, :)
@@ -172,5 +172,5 @@
       ! Le panache va prendre au debut les caracteristiques de l'air contenu
       ! dans cette couche.
-      if (active(ig)) THEN
+      IF (active(ig)) THEN
         ztla(ig, 1) = zthl(ig, 1)
         zqta(ig, 1) = po(ig, 1)
@@ -196,6 +196,6 @@
       do ig = 1, ngrid
         active(ig) = active(ig) &
-                &                 .and. zw2(ig, l)>1.e-10 &
-                &                 .and. f_star(ig, l) + alim_star(ig, l)>1.e-10
+                &                 .AND. zw2(ig, l)>1.e-10 &
+                &                 .AND. f_star(ig, l) + alim_star(ig, l)>1.e-10
       enddo
 
@@ -284,5 +284,5 @@
 
       do ig = 1, ngrid
-        if (active(ig)) THEN
+        IF (active(ig)) THEN
           !          zw2m=max(0.5*(w_est(ig,l)+w_est(ig,l+1)),0.1)
           zw2m = w_est(ig, l + 1)
@@ -301,5 +301,5 @@
                                   + detr_q_coef * (zdqt(ig, l) / zw2m)**detr_q_power))
 
-          if (iflag_thermals_ed == 20) THEN
+          IF (iflag_thermals_ed == 20) THEN
             entr_star(ig, l) = f_star(ig, l) * zdz * (&
                     mix0 * 0.1 / (zalpha + 0.001)               &
@@ -315,5 +315,5 @@
           ! En dessous de lalim, on prend le max de alim_star et entr_star pour
           ! alim_star et 0 sinon
-          if (l<lalim(ig)) THEN
+          IF (l<lalim(ig)) THEN
             alim_star(ig, l) = max(alim_star(ig, l), entr_star(ig, l))
             entr_star(ig, l) = 0.
@@ -330,7 +330,7 @@
       !===========================================================================
 
-      activetmp(:) = active(:) .and. f_star(:, l + 1)>1.e-10
-      do ig = 1, ngrid
-        if (activetmp(ig)) THEN
+      activetmp(:) = active(:) .AND. f_star(:, l + 1)>1.e-10
+      do ig = 1, ngrid
+        IF (activetmp(ig)) THEN
           Zsat = .FALSE.
           ztla(ig, l) = (f_star(ig, l) * ztla(ig, l - 1) + &
@@ -347,5 +347,5 @@
       CALL thermcell_qsat(ngrid, activetmp, pplev(:, l), ztemp, zqta(:, l), zqsatth(:, l))
       do ig = 1, ngrid
-        if (activetmp(ig)) THEN
+        IF (activetmp(ig)) THEN
           ! on ecrit de maniere conservative (sat ou non)
           !          T = Tl +Lv/Cp ql
@@ -369,5 +369,5 @@
       enddo
 
-      if (prt_level>=20) PRINT*, 'coucou calcul detr 460: ig, l', ig, l
+      IF (prt_level>=20) PRINT*, 'coucou calcul detr 460: ig, l', ig, l
 
       !===========================================================================
@@ -377,5 +377,5 @@
       nbpb = 0
       do ig = 1, ngrid
-        if (zw2(ig, l + 1)>0. .and. zw2(ig, l + 1)<1.e-10) THEN
+        IF (zw2(ig, l + 1)>0. .AND. zw2(ig, l + 1)<1.e-10) THEN
           !               stop 'On tombe sur le cas particulier de thermcell_dry'
           !               PRINT*,'On tombe sur le cas particulier de thermcell_plume'
@@ -385,5 +385,5 @@
         endif
 
-        if (zw2(ig, l + 1)<0.) THEN
+        IF (zw2(ig, l + 1)<0.) THEN
           linter(ig) = (l * (zw2(ig, l + 1) - zw2(ig, l))  &
                   - zw2(ig, l)) / (zw2(ig, l + 1) - zw2(ig, l))
@@ -399,8 +399,8 @@
         wa_moy(ig, l + 1) = sqrt(zw2(ig, l + 1))
 
-        if (wa_moy(ig, l + 1)>wmaxa(ig)) THEN
+        IF (wa_moy(ig, l + 1)>wmaxa(ig)) THEN
           !   lmix est le niveau de la couche ou w (wa_moy) est maximum
           !on rajoute le calcul de lmix_bis
-          if (zqla(ig, l)<1.e-10) THEN
+          IF (zqla(ig, l)<1.e-10) THEN
             lmix_bis(ig) = l + 1
           endif
@@ -410,5 +410,5 @@
       enddo
 
-      if (nbpb>0) THEN
+      IF (nbpb>0) THEN
         PRINT*, 'WARNING on tombe ', nbpb, ' x sur un pb pour l=', l, ' dans thermcell_plume'
       endif
@@ -429,5 +429,5 @@
     enddo
 
-    if (prt_level>=20) PRINT*, 'coucou calcul detr 470: ig, l', ig, l
+    IF (prt_level>=20) PRINT*, 'coucou calcul detr 470: ig, l', ig, l
     RETURN
   end
